LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

entity part5 is
	port
	(
		SW	 : in std_logic_vector(7 downto 0);
		Key : in std_logic_vector(1 downto 0);
		Hex0 : out std_logic_vector(0 to 6);
		Hex1 : out std_logic_vector(0 to 6);
		Hex2 : out std_logic_vector(0 to 6);
		Hex3 : out std_logic_vector(0 to 6);
		Hex4 : out std_logic_vector(0 to 6);
		Hex5 : out std_logic_vector(0 to 6);		
		LEDR : out std_logic_vector(9 downto 0)
	);
end;


architecture behav of part5 is
   signal A, B, S1 : std_logic_vector(7 downto 0);
	signal S: std_logic_vector(8 downto 0);
	signal c : std_logic;
	signal k0, k1 : std_logic;
	signal clk0, clk1 : std_logic;
begin


	LEDR(9 downto 8) <= KEY;
	LEDR(7 downto 1) <= (others => '0');
   LEDR(0) <= c;
	k0 <= not Key(0);
	k1 <= not Key(1);
   
	R1: work.Reg8bit_With_Async_Reset port map( rst => k0, Clk => clk0, D => SW, Q => A);
	R2: work.Reg8bit_With_Async_Reset port map( rst => k0, Clk => clk1, D => SW, Q => B);
	
	toggle_reg: process (k1) is
	   variable T : std_logic := '0';
	begin
		if rising_edge(k1) THEN
		   if T='0' THEN
				clk0<='1';
				clk1<='0';
				T:='1';
			else
				clk1<='1';
				clk0<='0';
				T:='0';
			end if;			
		end if;
	end process;

--   increment_bottom: process (k1) is
--	   variable S1M : std_logic_vector(7 downto 0) := (others=> '0');
--	begin
--		if rising_edge(k1) THEN
--			S1M := S1M+'1';
--		end if;
--		S1 <= S1M;
--	end process;
	
	S <= std_logic_vector'(('0' & A) + ('0' & B));
	c <= S(8);
	
   D1: entity work.DisplayDigit(behav)
	port map (A(7 downto 4), HEX3);
	
   D2: entity work.DisplayDigit(behav)
	port map (A(3 downto 0), HEX2);	
	
   D3: entity work.DisplayDigit(behav)
	port map (B(7 downto 4), HEX1);
	
   D4: entity work.DisplayDigit(behav)
	port map (B(3 downto 0), HEX0);	

   D5: entity work.DisplayDigit(behav)
	port map (S(7 downto 4), HEX5);
	
   D6: entity work.DisplayDigit(behav)
	port map (S(3 downto 0), HEX4);		
	    	
	
end behav;